﻿using Microsoft.AspNetCore.Components;
using System;
using System.Threading;

namespace blazor_lifetime.Shared
{
    public class FirstLevelComponentModel : ComponentBase
    {
        protected string SyncParameter { get; set; }

        protected override void OnInitialized()
        {
            Console.WriteLine($"{GetType().Name}.OnInitialized.Start");
            Thread.Sleep(500);
            SyncParameter = "value 123";
            Console.WriteLine($"{GetType().Name}.OnInitialized.End");
        }

        protected override void OnParametersSet()
        {
            Console.WriteLine($"{GetType().Name}.OnParametersSet.Start");
            Thread.Sleep(500);
            Console.WriteLine($"{GetType().Name}.OnParametersSet.End");
        }

        protected override void OnAfterRender(bool firstRender)
        {
            if (firstRender)
            {
                Console.WriteLine($"{GetType().Name}.OnAfterRender(FirstRender).Start");
                Thread.Sleep(500);
                Console.WriteLine($"{GetType().Name}.OnAfterRender(FirstRender).End");
            }
            else
            {
                Console.WriteLine($"{GetType().Name}.OnAfterRender.Start");
                Thread.Sleep(500);
                Console.WriteLine($"{GetType().Name}.OnAfterRender.End");
            }
        }
    }
}